
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <windows.h>

#include "..\Hotpatch.h"
#define _s(s) (sizeof(s)/sizeof(*(s)))

#ifdef __cplusplus
extern "C" {
#endif
int __security_cookie;
void __cdecl __security_init_cookie(void) {
}
int __fastcall __security_check_cookie(int i) {
  i;
  return(1);
}
#ifdef __cplusplus
}
#endif


const LPCTSTR szHpFixupType[] = {
  _T("NONE"),
  _T("VA32"),
  _T("PC32"),
  _T("VA64"),
  _T("PC64")
};

const LPCTSTR szHookType[] = {
  _T("NONE     "),
  _T("VA32     "),
  _T("X86_JMP  "),
  _T("PCREL32  "),
  _T("X86_JMP2B"),
  _T("VA64     "),
  _T("IA64_BRL "),
  _T("IA64_BR  "),
  _T("AMD64_IND"),
  _T("AMD64_CNT")
};

const LPCTSTR  szModuleIdMethod[] = {
  _T("HOTP_ID_None"),
  _T("HOTP_ID_PeHeaderHash1"),
  _T("HOTP_ID_PeHeaderHash2"),
  _T("HOTP_ID_PeChecksum"),
  _T("HOTP_ID_PeDebugSignature")
};


INT _tmain(INT argc, TCHAR *argv[]) {
  HMODULE p;
  ULONG i, j;
  PIMAGE_NT_HEADERS64 pPE;
  PIMAGE_SECTION_HEADER pSec;
  PHOTPATCH_HEADER pHp;
  PHOTPATCH_FIXUP_REGION pHpFixupRgn;
  PHOTPATCH_FIXUP_ENTRY pHpFixupEntry;
  PHOTPATCH_VALIDATION pHpValidation;
  PBYTE pb;
  PHOTPATCH_HOOK pHpHook;

  if(argc < 2) {
    return(_tprintf(_T("hotp1 <Image> [HotPatch]\nhotp1 Image - show hotpatch information\nhotp1 Image HotPatch - write hotpatch")));
  }

  if(argc > 2) {
    //create HotPatch - add .hotp1 section or write to it if exists
    _tprintf(_T("Not yet implemeted.\n"));
  }
  else {
    //show HotPatch

    p = LoadLibraryEx(argv[1], NULL, DONT_RESOLVE_DLL_REFERENCES);   
    __try {
      pPE = (PIMAGE_NT_HEADERS64)((ULONG_PTR)p +((PIMAGE_DOS_HEADER)p)->e_lfanew);
      if((pPE->Signature != IMAGE_NT_SIGNATURE) || ((pPE->FileHeader.Machine != IMAGE_FILE_MACHINE_AMD64) && (pPE->FileHeader.Machine != IMAGE_FILE_MACHINE_I386)) || ((pPE->OptionalHeader.Magic != IMAGE_NT_OPTIONAL_HDR64_MAGIC) && (pPE->OptionalHeader.Magic != IMAGE_NT_OPTIONAL_HDR32_MAGIC)) || ((i = pPE->FileHeader.NumberOfSections) == 0)) {
        return(_tprintf(_T("ERROR: Bad <Module> format!\n")));
      }
      pSec = (PIMAGE_SECTION_HEADER)IMAGE_FIRST_SECTION(pPE);
      do {
        if(*(PLONGLONG)&pSec->Name == HOTP_SECTION_NAMELL) {
          if(pSec->Misc.VirtualSize >= HOTP_SECTION_MIN_SIZE) {
            break;
          }
        }
        pSec++;
      } while(--i);
      if(i) {
        pHp = (PHOTPATCH_HEADER)((ULONG_PTR)p +pSec->VirtualAddress/*PointerToRawData*/);

        if(pHp->Signature == HOTP_SIGNATURE) {
          _tprintf(_T("HOTP_SIGNATURE"));
        }
        else {
          _tprintf(_T("%08X"), pHp->Signature);
        }

        if(pHp->Version == HOTP_VERSION_1) {
          _tprintf(_T("\nHOTP_VERSION_1"));
        }
        else {
          _tprintf(_T("\n%08X"), pHp->Version);
        }

        _tprintf(_T("\n%08X"), i = pHp->FixupRgnCount);
        pHpFixupRgn = (PHOTPATCH_FIXUP_REGION)((ULONG_PTR)p +pHp->FixupRgnRva);
        while(i--) {
          _tprintf(_T("\n%08X %04X"), pHpFixupRgn->RvaHi << 12, j = pHpFixupRgn->Count);
          pHpFixupEntry = (PHOTPATCH_FIXUP_ENTRY)pHpFixupRgn->Fixup;
          while(j--) {
            if(pHpFixupEntry->FixupType < _s(szHpFixupType)) {
              _tprintf(_T("\n     %03X %s"), pHpFixupEntry->RvaOffset, szHpFixupType[pHpFixupEntry->FixupType]);
            }
            else {
              _tprintf(_T("\n     %03X %04X"), pHpFixupEntry->RvaOffset, pHpFixupEntry->FixupType);
            }
            pHpFixupEntry++;
          }
          pHpFixupRgn = (PHOTPATCH_FIXUP_REGION)pHpFixupEntry;
        }

        _tprintf(_T("\n%08X"), i = pHp->ValidationCount);
        pHpValidation = (PHOTPATCH_VALIDATION)((ULONG_PTR)p +pHp->ValidationArrayRva);
        while(i--) {
          if(pHpValidation->OptionFlags == HOTP_Valid_Hook_Target) {
            _tprintf(_T("\n%08X %08X %04X SKIP"), pHpValidation->SourceRva, pHpValidation->TargetRva, j = pHpValidation->ByteCount);
          }
          else {
            _tprintf(_T("\n%08X %08X %04X %04X"), pHpValidation->SourceRva, pHpValidation->TargetRva, j = pHpValidation->ByteCount, pHpValidation->OptionFlags);
          }
          pb = (PBYTE)((ULONG_PTR)p +pHpValidation->SourceRva);
          while(j--) {
            _tprintf(_T(" %02X"), *pb++);
          }
          pHpValidation++;
        }

        _tprintf(_T("\n%08X"), i = pHp->HookCount);
        pHpHook = (PHOTPATCH_HOOK)((ULONG_PTR)p +pHp->HookArrayRva);
        while(i--) {
          switch(pHpHook->HookType) {
            case HOTP_Hook_None :
              j = 0;
              break;
            case HOTP_Hook_VA32 :
              j = 1;
              break;
            case HOTP_Hook_X86_JMP :
              j = 2;
              break;
            case HOTP_Hook_PCREL32 :
              j = 3;
              break;
            case HOTP_Hook_X86_JMP2B :
              j = 4;
              break;
            case HOTP_Hook_VA64 :
              j = 5;
              break;
            case HOTP_Hook_IA64_BRL :
              j = 6;
              break;
            case HOTP_Hook_IA64_BR :
              j = 7;
              break;
            case HOTP_Hook_AMD64_IND :
              j = 8;
              break;
            case HOTP_Hook_AMD64_CNT :
              j = 9;
              break;
            default :
              j = 10;
              break;
          }
          if(j > _s(szHookType)) {
            _tprintf(_T("\n%02X %02X %08X %08X %08X"), pHpHook->HookType, pHpHook->HookOptions, pHpHook->HookRva, pHpHook->HotpRva, pHpHook->ValidationRva);
          }
          else {
            _tprintf(_T("\n%s %02X %08X %08X %08X"), szHookType[j], pHpHook->HookOptions, pHpHook->HookRva, pHpHook->HotpRva, pHpHook->ValidationRva);
          }

          if(pHpHook->ValidationRva) {
            pHpValidation = (PHOTPATCH_VALIDATION)((ULONG_PTR)p +pHpHook->ValidationRva);
            _tprintf(_T(" %08X %08X %04X %04X"), pHpValidation->SourceRva, pHpValidation->TargetRva, j = pHpValidation->ByteCount, pHpValidation->OptionFlags);
            pb = (PBYTE)((ULONG_PTR)p +pHpValidation->SourceRva);
            while(j--) {
              _tprintf(_T(" %02X"), *pb++);
            }
          }
          pHpHook++;
        }
        _tprintf(_T("\n%016I64X\n%016I64X\n%\"%hs\"\n"), pHp->OrigHotpBaseAddress, pHp->OrigTargetBaseAddress, (PSTR)((ULONG_PTR)p +pHp->TargetNameRva));
        switch(pHp->ModuleIdMethod) {
          case HOTP_ID_None :
            j = 0;
            break;
          case HOTP_ID_PeHeaderHash1 :
            j = 1;
            break;
          case HOTP_ID_PeHeaderHash2 :
            j = 2;
            break;
          case HOTP_ID_PeChecksum :
            j = 3;
            break;
          case HOTP_ID_PeDebugSignature :
            j = 4;
            break;
          default :
            j = 5;
            break;
        }
        if(j > _s(szModuleIdMethod)) {
          _tprintf(_T("%08X\n"), pHp->ModuleIdMethod);
        }
        else {
          _tprintf(_T("%s\n"), szModuleIdMethod[j]);
        }
        for(pb = (PBYTE)&pHp->TargetModuleIdValue, i = 0; i < sizeof(pHp->TargetModuleIdValue); pb++, i++) {
          _tprintf(_T("%02X "), *pb);
        }
      }
    }
    __except(EXCEPTION_EXECUTE_HANDLER) {
    }
  }
  return(0);
}
